package com.ibm.xml.parser;

import java.util.Enumeration;
import java.util.Vector;
import org.w3c.dom.Node;

public class Attlist extends Child {
   static final long serialVersionUID = -8168631922182992992L;
   String name;
   Vector attDefs = new Vector();

   public Attlist(String var1) {
      this.name = var1;
   }

   public synchronized Object clone() {
      ((Child)this).checkFactory();
      Attlist var1 = super.factory.createAttlist(this.name);
      ((Child)var1).setFactory(((Child)this).getFactory());
      var1.attDefs.ensureCapacity(this.size());

      for(int var2 = 0; var2 < this.size(); ++var2) {
         var1.addElement((AttDef)((AttDef)this.attDefs.elementAt(var2)).clone());
      }

      return var1;
   }

   public synchronized boolean equals(Node var1, boolean var2) {
      if (var1.getNodeType() != this.getNodeType()) {
         return false;
      } else {
         Attlist var3 = (Attlist)var1;
         if (!var3.getName().equals(this.getName())) {
            return false;
         } else if (var3.size() != this.size()) {
            return false;
         } else {
            for(int var4 = 0; var4 < var3.size(); ++var4) {
               AttDef var5 = var3.elementAt(var4);
               if (!var5.equals(this.elementAt(var4), true)) {
                  return false;
               }
            }

            return true;
         }
      }
   }

   public short getNodeType() {
      return 21;
   }

   public String getNodeName() {
      return "#attribute-definition-list";
   }

   public String getName() {
      return this.name;
   }

   public boolean addElement(AttDef var1) {
      if (this.contains(var1.getName())) {
         return false;
      } else {
         this.attDefs.addElement(var1);
         ((Child)var1).setParentNode(this);
         return true;
      }
   }

   public AttDef elementAt(int var1) {
      return (AttDef)this.attDefs.elementAt(var1);
   }

   public AttDef getAttDef(String var1) {
      for(int var2 = 0; var2 < this.size(); ++var2) {
         AttDef var3 = this.elementAt(var2);
         if (var1.equals(var3.getName())) {
            return var3;
         }
      }

      return null;
   }

   public boolean contains(String var1) {
      return this.getAttDef(var1) != null;
   }

   public int size() {
      return this.attDefs.size();
   }

   public Enumeration elements() {
      return this.attDefs.elements();
   }

   public void acceptPre(Visitor var1) throws Exception {
      var1.visitAttlistPre(this);
   }

   public void acceptPost(Visitor var1) throws Exception {
      var1.visitAttlistPost(this);
   }
}
