package com.ibm.xml.parser;

import org.w3c.dom.Node;

public class ElementDecl extends Child {
   static final long serialVersionUID = 1933367195772929307L;
   public static final int EMPTY = 1;
   public static final int ANY = 2;
   public static final int MODEL_GROUP = 4;
   String name;
   ContentModel contentModel;

   public ElementDecl(String var1, ContentModel var2) {
      this.name = var1;
      this.contentModel = var2;
   }

   public synchronized Object clone() {
      ((Child)this).checkFactory();
      ElementDecl var1 = super.factory.createElementDecl(this.name, (ContentModel)null);
      ((Child)var1).setFactory(((Child)this).getFactory());
      var1.contentModel = (ContentModel)this.contentModel.clone();
      return var1;
   }

   public synchronized boolean equals(Node var1, boolean var2) {
      if (var1 == null) {
         return false;
      } else if (!(var1 instanceof ElementDecl)) {
         return false;
      } else {
         ElementDecl var3 = (ElementDecl)var1;
         return !var3.getName().equals(this.getName()) ? false : var3.contentModel.equals(this.contentModel);
      }
   }

   public short getNodeType() {
      return 20;
   }

   public String getNodeName() {
      return "#element-declaration";
   }

   public String getName() {
      return this.name;
   }

   public void setName(String var1) {
      this.name = var1;
   }

   public int getContentType() {
      return this.getXML4JContentModel().getType();
   }

   public void setContentType(int var1) {
      this.getXML4JContentModel().setType(var1);
   }

   public void acceptPre(Visitor var1) throws Exception {
      var1.visitElementDeclPre(this);
   }

   public void acceptPost(Visitor var1) throws Exception {
      var1.visitElementDeclPost(this);
   }

   public ContentModel getXML4JContentModel() {
      return this.contentModel;
   }
}
