package com.ibm.xml.parser;

import java.io.Serializable;
import java.util.Enumeration;
import java.util.Hashtable;

public class EntityPool implements Serializable {
   static final long serialVersionUID = -8639077697333708869L;
   private Hashtable m_entity = new Hashtable();
   private Hashtable m_para = new Hashtable();

   public boolean add(EntityDecl var1) {
      String var2 = var1.getNodeName();
      if (var1.isParameter()) {
         if (this.m_para.containsKey(var2)) {
            return false;
         }

         this.m_para.put(var2, var1);
      } else {
         if (this.m_entity.containsKey(var2)) {
            return false;
         }

         this.m_entity.put(var2, var1);
      }

      return true;
   }

   EntityDecl refer(String var1) {
      return (EntityDecl)this.m_entity.get(var1);
   }

   EntityDecl referPara(String var1) {
      return (EntityDecl)this.m_para.get(var1);
   }

   Enumeration elements() {
      return this.m_entity.elements();
   }

   Enumeration parameterEntityElements() {
      return this.m_para.elements();
   }

   Hashtable getEntityHash() {
      return this.m_entity;
   }
}
