package com.ibm.xml.parser;

public class StylesheetPI extends TXPI {
   static final long serialVersionUID = -5551516051977603120L;
   public static final String S_XMLSTYLESHEET = "xml:stylesheet";
   public static final String S_XMLALTSTYLESHEET = "xml:alternate-stylesheet";
   public static final String S_STYLESHEET = "stylesheet";
   public static final String S_ALTSTYLESHEET = "alternate-stylesheet";
   public static final String S_TEXTCSS = "text/css";
   String type;
   String hrefURI;
   String title;

   public StylesheetPI(String var1) {
      this("xml:stylesheet", " type=\"text/css\" href=\"" + var1 + "\"", "text/css", var1, (String)null);
   }

   public StylesheetPI(String var1, String var2, String var3) {
      this("xml:stylesheet", var3 == null ? " type=\"" + var1 + "\" href=\"" + var2 + "\"" : " type=\"" + var1 + "\" href=\"" + var2 + "\" title=\"" + var3 + "\"", var1, var2, var3);
   }

   public StylesheetPI(String var1, String var2, String var3, String var4) {
      this(var1, var4 == null ? " type=\"" + var2 + "\" href=\"" + var3 + "\"" : " type=\"" + var2 + "\" href=\"" + var3 + "\" title=\"" + var4 + "\"", var2, var3, var4);
   }

   public StylesheetPI(String var1, String var2, String var3, String var4, String var5) throws LibraryException {
      super(var1, var2);
      if (!var1.equals("xml:stylesheet") && !var1.equals("xml:alternate-stylesheet")) {
         throw new LibraryException("Invalid stylesheet declaration detected.");
      } else {
         this.type = var3;
         this.hrefURI = var4;
         this.title = var5;
      }
   }

   public synchronized Object clone() {
      ((Child)this).checkFactory();
      StylesheetPI var1 = super.factory.createStylesheetPI(super.name, super.data, this.type, this.hrefURI, this.title);
      ((Child)var1).setFactory(((Child)this).getFactory());
      return var1;
   }

   public String getType() {
      return this.type;
   }

   public String getHref() {
      return this.hrefURI;
   }

   public String getTitle() {
      return this.title;
   }
}
