package com.ibm.xml.parser;

import java.io.Serializable;
import java.util.Vector;
import org.w3c.dom.Attr;
import org.w3c.dom.DOMException;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;

class TXAttributeList extends Vector implements NamedNodeMap, Cloneable, Serializable {
   static final long serialVersionUID = 8198968721269694477L;
   Element parentElement;

   public TXAttributeList() {
   }

   public synchronized Object clone() {
      TXAttributeList var1 = new TXAttributeList();
      var1.parentElement = this.parentElement;

      for(int var2 = 0; var2 < this.getLength(); ++var2) {
         var1.setNamedItem((Attr)((TXAttribute)this.item(var2)).clone());
      }

      return var1;
   }

   public synchronized int indexOf(String var1) {
      for(int var2 = 0; var2 < ((Vector)this).size(); ++var2) {
         TXAttribute var3 = (TXAttribute)((Vector)this).elementAt(var2);
         if (var3.getName().equals(var1)) {
            return var2;
         }
      }

      return -1;
   }

   public Node getNamedItem(String var1) {
      int var2 = this.indexOf(var1);
      return var2 < 0 ? null : (Node)((Vector)this).elementAt(var2);
   }

   public Node setNamedItem(Node var1) throws DOMException {
      if (var1.getNodeType() != 2) {
         throw new TXDOMException((short)3, "Not Attribute node");
      } else if (this.parentElement.getOwnerDocument() != var1.getOwnerDocument()) {
         throw new TXDOMException((short)4, "Specified child was created from a different document.");
      } else {
         TXAttribute var2 = (TXAttribute)var1;
         Attr var3 = null;
         int var4 = this.indexOf(var2.getNodeName());
         if (var4 < 0) {
            ((Child)var2).setParentNode(this.parentElement);
            ((Vector)this).addElement(var2);
         } else {
            var3 = (Attr)((Vector)this).elementAt(var4);
            ((Vector)this).setElementAt(var2, var4);
            ((Child)var2).setParentNode(this.parentElement);
         }

         if (this.parentElement != null) {
            ((Child)this.parentElement).clearDigest();
         }

         return var3;
      }
   }

   public Node removeNamedItem(String var1) throws DOMException {
      int var2 = this.indexOf(var1);
      if (var2 < 0) {
         throw new TXDOMException((short)8, "Attribute `" + var1 + "' is not found.");
      } else {
         TXAttribute var3 = (TXAttribute)((Vector)this).elementAt(var2);
         ((Vector)this).removeElementAt(var2);
         ((Child)var3).setParentNode((Node)null);
         if (this.parentElement != null) {
            ((Child)this.parentElement).clearDigest();
         }

         return var3;
      }
   }

   public void clear() {
      ((Vector)this).removeAllElements();
   }

   public Node item(int var1) {
      return var1 >= 0 && ((Vector)this).size() > var1 ? (Node)((Vector)this).elementAt(var1) : null;
   }

   public int getLength() {
      return ((Vector)this).size();
   }

   public void setParent(Element var1) {
      for(int var2 = 0; var2 < this.getLength(); ++var2) {
         TXAttribute var3 = (TXAttribute)this.item(var2);
         ((Child)var3).setParentNode(var1);
      }

      this.parentElement = var1;
   }

   public TXAttribute[] makeArray() {
      TXAttribute[] var1 = new TXAttribute[((Vector)this).size()];
      ((Vector)this).copyInto(var1);
      return var1;
   }
}
