package com.ibm.xml.parser;

import org.w3c.dom.Node;
import org.w3c.dom.Notation;

public class TXNotation extends Child {
   static final long serialVersionUID = -1546534879299424756L;
   String name;
   ExternalID externalID;

   public TXNotation(String var1, ExternalID var2) {
      this.name = var1;
      this.externalID = var2;
   }

   public synchronized Object clone() {
      ((Child)this).checkFactory();
      TXNotation var1 = super.factory.createNotation(this.name, this.externalID);
      ((Child)var1).setFactory(((Child)this).getFactory());
      return var1;
   }

   public synchronized boolean equals(Node var1, boolean var2) {
      if (var1 == null) {
         return false;
      } else if (!(var1 instanceof TXNotation)) {
         return false;
      } else {
         TXNotation var3 = (TXNotation)var1;
         return !this.getName().equals(var3.getName()) ? false : this.getExternalID().equals(var3.getExternalID());
      }
   }

   public short getNodeType() {
      return 12;
   }

   public String getNodeName() {
      return this.name;
   }

   /** @deprecated */
   public String getName() {
      return this.name;
   }

   /** @deprecated */
   public void setName(String var1) {
      this.name = var1;
   }

   public String getSystemId() {
      return this.externalID.getSystemLiteral();
   }

   public String getPublicId() {
      return this.externalID.getPubidLiteral();
   }

   public ExternalID getExternalID() {
      return this.externalID;
   }

   public void acceptPre(Visitor var1) throws Exception {
      var1.visitNotationPre(this);
   }

   public void acceptPost(Visitor var1) throws Exception {
      var1.visitNotationPost(this);
   }

   protected Notation getNotationImpl() {
      return new NotationImpl(this.name, this.externalID);
   }
}
