package com.ibm.xml.parser;

import org.w3c.dom.Node;
import org.w3c.dom.ProcessingInstruction;

public class TXPI extends Child implements ProcessingInstruction {
   static final long serialVersionUID = 5857404877602965574L;
   String name;
   String data;

   public TXPI(String var1, String var2) {
      this.name = var1;
      if (var2.length() <= 0) {
         this.data = var2;
      } else {
         int var3;
         for(var3 = 0; var3 < var2.length() && XMLChar.isSpace(var2.charAt(var3)); ++var3) {
         }

         this.data = var2.substring(var3);
      }
   }

   public synchronized Object clone() {
      ((Child)this).checkFactory();
      TXPI var1 = (TXPI)super.factory.createProcessingInstruction(this.name, this.data);
      ((Child)var1).setFactory(((Child)this).getFactory());
      return var1;
   }

   public synchronized boolean equals(Node var1, boolean var2) {
      if (var1 == null) {
         return false;
      } else if (!(var1 instanceof ProcessingInstruction)) {
         return false;
      } else {
         ProcessingInstruction var3 = (ProcessingInstruction)var1;
         return var3.getTarget().equals(this.getTarget()) && var3.getData().equals(this.getData());
      }
   }

   public short getNodeType() {
      return 7;
   }

   public String getNodeName() {
      return this.getTarget();
   }

   /** @deprecated */
   public String getName() {
      return this.name;
   }

   public String getTarget() {
      return this.name;
   }

   public void setTarget(String var1) {
      this.name = var1;
      ((Child)this).clearDigest();
   }

   public String getData() {
      return this.data;
   }

   public String getNodeValue() {
      return this.getData();
   }

   public void setData(String var1) {
      this.data = var1;
      ((Child)this).clearDigest();
   }

   public void setNodeValue(String var1) {
      this.setData(var1);
   }

   public String getText() {
      return "";
   }

   public void acceptPre(Visitor var1) throws Exception {
      var1.visitPIPre(this);
   }

   public void acceptPost(Visitor var1) throws Exception {
      var1.visitPIPost(this);
   }
}
