package com.ibm.xml.parser;

import org.w3c.dom.DOMException;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.Text;

public class TXText extends TXCharacterData implements Text {
   static final long serialVersionUID = -8266596319046593304L;
   boolean isIgnorableWhitespace = false;

   public TXText(String var1) {
      super.data = var1;
   }

   public synchronized Object clone() {
      ((Child)this).checkFactory();
      TXText var1 = (TXText)super.factory.createTextNode(super.data);
      ((Child)var1).setFactory(((Child)this).getFactory());
      var1.setIsIgnorableWhitespace(this.getIsIgnorableWhitespace());
      return var1;
   }

   public boolean equals(Node var1, boolean var2) {
      if (var1 == null) {
         return false;
      } else {
         return !(var1 instanceof Text) ? false : ((Text)var1).getData().equals(((TXCharacterData)this).getData());
      }
   }

   public short getNodeType() {
      return 3;
   }

   public String getNodeName() {
      return "#text";
   }

   public String getText() {
      return ((TXCharacterData)this).getData();
   }

   public boolean getIsIgnorableWhitespace() {
      return this.isIgnorableWhitespace;
   }

   public void setIsIgnorableWhitespace(boolean var1) {
      this.isIgnorableWhitespace = var1;
   }

   public String getLanguage() {
      if (super.parent == null) {
         return null;
      } else if (super.parent instanceof TXElement) {
         return ((TXElement)super.parent).getLanguage();
      } else {
         return super.parent instanceof GeneralReference ? ((GeneralReference)super.parent).getLanguage() : null;
      }
   }

   /** @deprecated */
   public synchronized void splice(Element var1, int var2, int var3) throws IllegalArgumentException, RuntimeException {
      if (!(var1 instanceof TXElement)) {
         throw new IllegalArgumentException("com.ibm.xml.parser.TXText#splice(): An instance of TXElement is required.");
      } else {
         String var4 = super.data.substring(var2, var3);
         String var5 = super.data.substring(var2 + var3);
         super.data = super.data.substring(0, var2);
         ((Child)this).clearDigest();
         Parent var6 = (Parent)((Child)this).getParentNode();
         if (var6 == null) {
            throw new RuntimeException("com.ibm.xml.parser.TXText#splice(): This Text Node has no parent and can not be spliced.");
         } else {
            ((Child)this).checkFactory();
            var1.insertBefore(super.factory.createTextNode(var4), (Node)null);
            var6.insertAfter(var1, this);
            if (var5.length() > 0) {
               var6.insertAfter(super.factory.createTextNode(var5), this);
            }

         }
      }
   }

   public Text splitText(int var1) throws DOMException {
      if (var1 >= 0 && var1 <= super.data.length()) {
         ((Child)this).checkFactory();
         Text var2 = super.factory.createTextNode(super.data.substring(var1));
         ((TXCharacterData)this).setData(((TXCharacterData)this).substringData(0, var1));
         Parent var3 = (Parent)((Child)this).getParentNode();
         if (var3 == null) {
            throw new RuntimeException("com.ibm.xml.parser.TXText#splitText(): This Text Node has no parent and can not be split.");
         } else {
            var3.insertAfter(var2, this);
            return var2;
         }
      } else {
         throw new TXDOMException((short)1, "Out of bounds: " + var1 + ", the length of data is " + super.data.length());
      }
   }

   public static String trim(String var0) {
      return trim(var0, true, true);
   }

   public static String trim(String var0, boolean var1, boolean var2) {
      char[] var3 = var0.toCharArray();
      int var4 = var3.length;
      boolean var5 = false;

      int var6;
      for(var6 = 0; var6 < var4 && !XMLChar.isSpace(var3[var6]); ++var6) {
      }

      int var7 = var6;

      for(boolean var8 = false; var6 < var4; ++var6) {
         char var9 = var3[var6];
         if (XMLChar.isSpace(var9)) {
            if (!var8) {
               if (var9 != ' ') {
                  var5 = true;
               }

               var3[var7++] = ' ';
            } else {
               var5 = true;
            }

            var8 = true;
         } else {
            var3[var7++] = var9;
            var8 = false;
         }
      }

      if (var2 && var7 >= 1 && var3[var7 - 1] == ' ') {
         var5 = true;
         --var7;
      }

      int var10 = 0;
      if (var1 && var7 > 0 && var3[0] == ' ') {
         var5 = true;
         ++var10;
      }

      if (var5) {
         return new String(var3, var10, var7 - var10);
      } else {
         return var0;
      }
   }

   public static String makePrintable(String var0) {
      StringBuffer var1 = new StringBuffer(var0.length() * 2);

      for(int var2 = 0; var2 < var0.length(); ++var2) {
         char var3 = var0.charAt(var2);
         if (var3 == '\r') {
            var1.append("\\r");
         } else if (var3 == '\n') {
            var1.append("\\n");
         } else if (var3 == '\t') {
            var1.append("\\t");
         } else if (var3 == '\b') {
            var1.append("\\b");
         } else if (var3 == '\f') {
            var1.append("\\f");
         } else if (var3 == '"') {
            var1.append("\\\"");
         } else if (var3 == '\\') {
            var1.append("\\\\");
         } else {
            var1.append((char)var3);
         }
      }

      return var1.toString();
   }

   public void acceptPre(Visitor var1) throws Exception {
      var1.visitTextPre(this);
   }

   public void acceptPost(Visitor var1) throws Exception {
      var1.visitTextPost(this);
   }

   /** @deprecated */
   static boolean isText(Object var0) {
      return !(var0 instanceof TXCDATASection) && var0 instanceof TXText;
   }
}
