package com.ibm.xml.parser.util;

import com.ibm.xml.parser.EndTraversalException;
import com.ibm.xml.parser.ToNextSiblingTraversalException;
import com.ibm.xml.parser.TreeTraversal;
import com.ibm.xml.parser.Visitee;
import com.ibm.xml.parser.Visitor;
import org.w3c.dom.Node;

public class RecursivePreorderTreeTraversal extends TreeTraversal {
   boolean endTraversal = false;

   public RecursivePreorderTreeTraversal(Visitor var1) {
      super(var1);
      this.endTraversal = false;
   }

   public void traverse(Node var1) throws Exception {
      try {
         if (var1 != null && !this.endTraversal) {
            try {
               ((Visitee)var1).acceptPre(((TreeTraversal)this).getVisitor());

               for(Node var2 = var1.getFirstChild(); var2 != null && !this.endTraversal; var2 = var2.getNextSibling()) {
                  this.traverse(var2);
               }
            } catch (ToNextSiblingTraversalException var3) {
            }

            if (!this.endTraversal) {
               ((Visitee)var1).acceptPost(((TreeTraversal)this).getVisitor());
               return;
            }
         }
      } catch (EndTraversalException var4) {
         this.endTraversal = true;
      }

   }
}
