package com.ibm.xml.parser;

import com.ibm.xml.framework.EntityPool;
import com.ibm.xml.framework.ParserState;
import com.ibm.xml.framework.StringPool;
import com.ibm.xml.framework.XMLDocumentHandler;
import com.ibm.xml.framework.XMLDocumentTypeHandler;
import java.io.IOException;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;
import org.xml.sax.EntityResolver;
import org.xml.sax.ErrorHandler;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

class Parser$Handler implements XMLDocumentTypeHandler, XMLDocumentHandler, ErrorHandler, EntityResolver {
   // $FF: synthetic field
   private final Parser this$0;

   public void doctypeDecl(int var1) throws Exception {
      Vector var2 = this.this$0.preRootHandlers;
      if (var2 != null) {
         Enumeration var3 = var2.elements();
         if (var3.hasMoreElements()) {
            TXDocument var4 = (TXDocument)this.this$0.getDocument();
            String var5 = this.this$0.getParserState().getStringPool().toString(var1);

            do {
               PreRootHandler var6 = (PreRootHandler)var3.nextElement();
               var6.handlePreRoot(var4, var5);
            } while(var3.hasMoreElements());
         }
      }

      this.this$0.doctypeDecl(var1);
   }

   public void startInternalSubset() throws Exception {
      this.this$0.startInternalSubset();
   }

   public void endInternalSubset() throws Exception {
      this.this$0.endInternalSubset();
   }

   public void startExternalSubset(int var1, int var2) throws Exception {
      this.this$0.startExternalSubset(var1, var2);
   }

   public void endExternalSubset() throws Exception {
      this.this$0.endExternalSubset();
   }

   public void elementDecl(int var1) throws Exception {
      this.this$0.elementDecl(var1);
   }

   public void unparsedEntityDecl(int var1) throws Exception {
      this.this$0.unparsedEntityDecl(var1);
   }

   public void attlistDecl(int var1, int var2) throws Exception {
      this.this$0.attlistDecl(var1, var2);
   }

   public void internalEntityDecl(int var1) throws Exception {
      this.this$0.internalEntityDecl(var1);
   }

   public void externalEntityDecl(int var1) throws Exception {
      this.this$0.externalEntityDecl(var1);
   }

   public void notationDecl(int var1) throws Exception {
      this.this$0.notationDecl(var1);
   }

   public void parameterEntityDecl(int var1) throws Exception {
      this.this$0.parameterEntityDecl(var1);
   }

   public boolean sendCharDataAsCharArray() {
      return this.this$0.sendCharDataAsCharArray();
   }

   public void endDocument() throws Exception {
      this.this$0.endDocument();
   }

   public void characters(int var1, boolean var2) throws Exception {
      this.this$0.characters(var1, var2);
   }

   public void ignorableWhitespace(int var1, boolean var2) throws Exception {
      this.this$0.ignorableWhitespace(var1, var2);
   }

   public void comment(int var1) throws Exception {
      if (this.this$0.isKeepComment) {
         this.this$0.comment(var1);
      } else {
         this.this$0.getParserState().getStringPool().releaseString(var1);
      }
   }

   public void characters(char[] var1, int var2, int var3, boolean var4) throws Exception {
      this.this$0.characters(var1, var2, var3, var4);
   }

   public void ignorableWhitespace(char[] var1, int var2, int var3, boolean var4) throws Exception {
      this.this$0.ignorableWhitespace(var1, var2, var3, var4);
   }

   public void startDocument(int var1, int var2, int var3) throws Exception {
      this.this$0.startDocument(var1, var2, var3);
   }

   public void startEntityReference(int var1) throws Exception {
      this.this$0.startEntityReference(var1);
      ReferenceHandler var2 = this.this$0.referenceHandler;
      if (var2 != null) {
         ParserState var3 = this.this$0.getParserState();
         EntityPool var4 = var3.getEntityPool();
         StringPool var5 = var3.getStringPool();
         String var6 = var5.toString(var4.getEntityName(var1));
         var2.startReference(var6);
      }

   }

   public void endEntityReference(int var1) throws Exception {
      this.this$0.endEntityReference(var1);
      ReferenceHandler var2 = this.this$0.referenceHandler;
      if (var2 != null) {
         ParserState var3 = this.this$0.getParserState();
         EntityPool var4 = var3.getEntityPool();
         StringPool var5 = var3.getStringPool();
         String var6 = var5.toString(var4.getEntityName(var1));
         var2.endReference(var6);
      }

   }

   public void processingInstruction(int var1, int var2) throws Exception {
      if (this.this$0.piHandlers != null) {
         Enumeration var3 = this.this$0.piHandlers.elements();
         if (var3.hasMoreElements()) {
            StringPool var4 = this.this$0.getParserState().getStringPool();
            String var5 = var4.toString(var1);
            String var6 = var4.toString(var2);

            do {
               PIHandler var7 = (PIHandler)var3.nextElement();
               var7.handlePI(var5, var6);
            } while(var3.hasMoreElements());
         }
      }

      this.this$0.processingInstruction(var1, var2);
   }

   public void startElement(int var1, int var2) throws Exception {
      this.this$0.startElement(var1, var2);
      TagHandler var3 = this.this$0.tagHandler;
      if (var3 != null) {
         TXElement var4 = this.this$0.getCurrentParent();
         var3.handleStartTag(var4, ((Parent)var4).hasChildNodes());
      }

      this.this$0.TXNamespaceCode(this.this$0.getCurrentParent(), var1, var2);
   }

   public void endElement(int var1) throws Exception {
      TagHandler var2 = this.this$0.tagHandler;
      if (var2 != null) {
         TXElement var3 = this.this$0.getCurrentParent();
         var2.handleEndTag(var3, ((Parent)var3).hasChildNodes());
      }

      StringPool var12 = this.this$0.getParserState().getStringPool();
      String var4 = var12.toString(var1);
      String[] var5 = new String[]{var4, " ALL "};
      Hashtable var6 = this.this$0.elementHandlerHash;
      if (var6 != null) {
         for(int var7 = 0; var7 < var5.length; ++var7) {
            Vector var8 = (Vector)var6.get(var5[var7]);
            if (var8 != null) {
               TXElement var9 = this.this$0.getCurrentParent();
               Enumeration var10 = var8.elements();

               while(var10.hasMoreElements()) {
                  ElementHandler var11 = (ElementHandler)var10.nextElement();
                  this.this$0.setRealParent(var11.handleElement(var9));
               }
            }
         }
      }

      this.this$0.endElement(var1);
   }

   public void warning(SAXParseException var1) throws SAXException {
      ++this.this$0.warnCount;
   }

   public void error(SAXParseException var1) throws SAXException {
      ++this.this$0.validityFailureCount;
      if (this.this$0.isEndBy1stError) {
         throw var1;
      }
   }

   public void fatalError(SAXParseException var1) throws SAXException {
      ++this.this$0.errorCount;
   }

   public InputSource resolveEntity(String var1, String var2) throws SAXException, IOException {
      Source var3 = this.this$0.streamProducer.getInputStream("", var1, var2);
      InputSource var4 = new InputSource();
      var4.setByteStream(var3.getInputStream());
      var4.setCharacterStream(var3.getReader());
      var4.setEncoding(var3.getEncoding());
      var4.setPublicId(var1);
      var4.setSystemId(var2);
      return var4;
   }

   Parser$Handler(Parser var1) {
      this.this$0 = var1;
      this.this$0 = var1;
   }
}
